
#ifndef RFIDREADER_SAMPLE_H
#define RFIDREADER_SAMPLE_H

/**
 * RFID Reader Register Manipulation Module
 * 
 * Provides an API for reading and writing registers of the MFRC522 RFID Reader.
 * The information in this module is informed by the data sheet and the Arduino Library.
 * 
 * Here is the Arduino library for the MFRC522:
 * https://github.com/miguelbalboa/rfid/tree/master/src
 * Items taken from the Arduino library:
 * - Register enum table (in MFRC522_data.h)
 * - PCD Command enum table (in MFRC522_data.h)
 * - PICC Command enum table (in MFRC522_data.h)
 */

#include <stdint.h>
#include <stdbool.h>

#include "RFIDReader_data.h"

void RFIDReader_writeReg(enum MFRC522_Register regAddr, uint8_t regData);

uint8_t RFIDReader_readReg(enum MFRC522_Register regAddr);

#endif